Index: trunk/kernel/mm/kcm.c
===================================================================
--- trunk/kernel/mm/kcm.c	(revision 690)
+++ trunk/kernel/mm/kcm.c	(revision 1)
@@ -33,730 +33,321 @@
 #include <page.h>
 #include <cluster.h>
-#include <kmem.h>
 #include <kcm.h>
 
-///////////////////////////////////////////////////////////////////////////////////////////
-//         global variables
-///////////////////////////////////////////////////////////////////////////////////////////
-
-extern chdev_directory_t    chdev_dir;          // allocated in kernel_init.c
-
-
-/////////////////////////////////////////////////////////////////////////////////////
-//        Local access functions
-/////////////////////////////////////////////////////////////////////////////////////
+/////////////////////////////////////////////////////////////////////////////////////
+// Extern global variable (defined in kmem.c file)
+/////////////////////////////////////////////////////////////////////////////////////
+
+extern uint32_t kmem_size_tbl[KMEM_TYPES_NR];
+
+
+/////////////////////////////////////////////////////////////////////////////////////
+// This function allocates one page from local PPM.
+/////////////////////////////////////////////////////////////////////////////////////
+static page_t * kcm_page_alloc( kcm_t * kcm )
+{
+	page_t    * page;
+    kmem_req_t  req;
+
+    req.type  = KMEM_PAGE;
+    req.size  = 0;
+    req.flags = AF_KERNEL;
+    page = kmem_alloc( &req );
+  
+	if( page == NULL )
+	{
+		printk("\n[ERROR] in %s failed to allocate page in cluster %d\n", 
+               __FUNCTION__ , local_cxy );
+	}
+
+	return page;
+}
 
 //////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the kcm_alloc() function.
-// It returns a pointer on a block allocated from an active kcm_page.
-// It makes a panic if no block is available in the selected page.
-// It changes the page status as required.
+// This static function returns pointer on allocated block from an active page.
+// It returns NULL if no block available in selected page.
+// It changes the page status if required.
 //////////////////////////////////////////////////////////////////////////////////////
-// @ kcm      : pointer on KCM allocator.
-// @ kcm_page : pointer on an active kcm_page.
-// @ return pointer on allocated block.
-/////////////////////////////////////////////////////////////////////////////////////
-static void * __attribute__((noinline)) kcm_get_block( kcm_t      * kcm,
-                                                       kcm_page_t * kcm_page )
-{
-    // initialise variables
-    uint32_t order  = kcm->order;
-    uint32_t count  = kcm_page->count;
-    uint64_t status = kcm_page->status;
-
-// check kcm page not full
-assert( __FUNCTION__, (count < 63) ,
-"kcm_page should not be full / cxy %x / order %d / count %d", local_cxy, order, count );
-
-    uint32_t index  = 1;
-    uint64_t mask   = (uint64_t)0x2;
-
-	// allocate first free block in kcm_page, update status,
-    // and count , compute index of allocated block in kcm_page 
-    while( index <= 63 )
-    {
-        if( (status & mask) == 0 )   // block found
-        {
-            // update page count and status
-            kcm_page->status = status | mask;
-            kcm_page->count  = count + 1;
-            break;      
-        }
-        
-        index++;
-        mask <<= 1;
-    }
-
-    // switch page to full if last block
-    if( (count + 1) == 63 )
-    {
-		list_unlink( &kcm_page->list);
-		kcm->active_pages_nr--;
-
-        list_add_first( &kcm->full_root , &kcm_page->list );
-		kcm->full_pages_nr ++;
-    }
-
-	// compute return pointer
-	void * ptr = (void *)((intptr_t)kcm_page + (index << order));
-
-	return ptr;
-
-}  // end kcm_get_block()
-
-/////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the kcm_free() function.
-// It releases a previously allocated block to the relevant kcm_page.
-// It makes a panic if the released block is not allocated in this page.
-// It changes the kcm_page status as required.
-/////////////////////////////////////////////////////////////////////////////////////
-// @ kcm        : pointer on kcm allocator.
-// @ kcm_page   : pointer on kcm_page.
-// @ block_ptr  : pointer on block to be released.
-/////////////////////////////////////////////////////////////////////////////////////
-static void __attribute__((noinline)) kcm_put_block ( kcm_t      * kcm,
-                                                      kcm_page_t * kcm_page,
-                                                      void       * block_ptr )
-{
-    // initialise variables
-    uint32_t order  = kcm->order;
-    uint32_t count  = kcm_page->count;
-    uint64_t status = kcm_page->status;
-    
-	// compute block index from block pointer and kcm_page pointer
-	uint32_t index = ((intptr_t)block_ptr - (intptr_t)kcm_page) >> order;
-
-    // compute mask in bit vector
-    uint64_t mask = ((uint64_t)0x1) << index;
-
-    if( (status & mask) == 0 )
-    {
-        printk("\n[WARNING] in %s : block[%x,%x] not allocated / kcm %x / kcm_page %x\n",
-        __FUNCTION__, local_cxy, block_ptr, kcm, kcm_page );
-        kcm_remote_display( local_cxy , kcm );
-        return;
-    }
-
-    // update status & count in kcm_page 
-	kcm_page->status = status & ~mask;
-	kcm_page->count  = count - 1;
-
-	// switch page to active if it was full
-	if( count == 63 )
-	{
-		list_unlink( &kcm_page->list );
-		kcm->full_pages_nr --;
-
-		list_add_last( &kcm->active_root, &kcm_page->list );
+static void * get_block( kcm_t      * kcm,
+                         kcm_page_t * page )
+{
+	int32_t index = bitmap_ffs( page->bitmap , sizeof(page->bitmap) ); 
+
+    // the page should be active 
+    if( page->active == 0 )
+    {
+        printk("\n[PANIC] in %s : kcm page should be active\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // the page should not be full
+    if( index == -1 )
+    {
+        printk("\n[PANIC] in %s : kcm page should be active\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+ 
+	bitmap_clear( page->bitmap , index );
+	page->refcount ++;
+
+    // change the page to busy if last block in page
+    if( page->refcount >= kcm->blocks_nr )
+    {
+        page->active = 0;
+		list_unlink( &page->list);
+		kcm->active_pages_nr --;
+
+		list_add_first( &kcm->busy_root , &page->list);
+		kcm->busy_pages_nr ++;
+        page->busy   = 1;
+    }
+
+	return (page->blk_tbl + index * kcm->block_size );
+}
+
+/////////////////////////////////////////////////////////////////////////////////////
+// This static function releases a previously allocated block.
+// It changes the page status if required.
+/////////////////////////////////////////////////////////////////////////////////////
+static void put_block ( kcm_t * kcm,
+                        void  * ptr )
+{
+	kcm_page_t * page;
+    uint32_t     index; 
+  
+	page = (kcm_page_t*)((intptr_t)ptr & CONFIG_PPM_PAGE_MASK);
+	index = ((uint8_t*)ptr - page->blk_tbl) / kcm->block_size;
+  
+	bitmap_set( page->bitmap , index );
+	page->refcount --;
+  
+    // change the page to active if it was busy
+	if( page->busy )
+	{
+		page->busy = 0;
+		list_unlink( &page->list );
+		kcm->busy_pages_nr --;
+
+		list_add_last( &kcm->active_root, &page->list );
 		kcm->active_pages_nr ++;
-	}
-
-}  // kcm_put_block()
-
-/////////////////////////////////////////////////////////////////////////////////////
-// This static function  returns one non-full kcm_page with the following policy :
-// - if the "active_list" is non empty, it returns the first "active" page,
-//   without modifying the KCM state.
-// - if the "active_list" is empty, it allocates a new page from PPM, inserts
-//   this page in the active_list, and returns it. 
-/////////////////////////////////////////////////////////////////////////////////////
-// @ kcm      : local pointer on local KCM allocator.
-// @ return pointer on a non-full kcm page if success / returns NULL if no memory.
-/////////////////////////////////////////////////////////////////////////////////////
-static kcm_page_t * __attribute__((noinline)) kcm_get_page( kcm_t * kcm )
-{
-    kcm_page_t * kcm_page;
-
-    uint32_t active_pages_nr = kcm->active_pages_nr;
-
-    if( active_pages_nr > 0 )       // return first active page
-    {
-        kcm_page = LIST_FIRST( &kcm->active_root , kcm_page_t , list );
-    }
-    else                            // allocate a new page from PPM
-	{
-        // get KCM order
-        uint32_t order = kcm->order;
-
-        // get one kcm_page from  PPM
-        page_t * page = ppm_alloc_pages( order + 6 - CONFIG_PPM_PAGE_ORDER );
-
-	    if( page == NULL )
-	    {
-
-#if DEBUG_KCM_ERROR
-printk("\n[ERROR] in %s : failed to allocate page in cluster %x\n",
-__FUNCTION__ , local_cxy );
-#endif
-		    return NULL;
-        }
-
-	    // get page base address
-	    xptr_t base_xp = ppm_page2base( XPTR( local_cxy , page ) );
-
-        // get local pointer on kcm_page 
-	    kcm_page = GET_PTR( base_xp );
-
-	    // initialize kcm_page descriptor
-	    kcm_page->status = 0;
-	    kcm_page->count  = 0;
-	    kcm_page->kcm    = kcm;
-	    kcm_page->page   = page;
-
-	    // introduce new page in KCM active_list
-	    list_add_first( &kcm->active_root , &kcm_page->list );
-	    kcm->active_pages_nr ++;
-	}
-
-	return kcm_page;
-
-}  // end kcm_get_page()
-
-//////////////////////////////
-void kcm_init( kcm_t    * kcm,
-	           uint32_t   order)
-{
-
-// check argument
-assert( __FUNCTION__, (order < CONFIG_PPM_PAGE_ORDER),
-"order argument %d too large", order );
-
-assert( __FUNCTION__, (order >= CONFIG_CACHE_LINE_ORDER),
-"order argument %d too small", order );
-
-	// initialize lock
-	remote_busylock_init( XPTR( local_cxy , &kcm->lock ) , LOCK_KCM_STATE );
-
-	// initialize KCM page lists
-	kcm->full_pages_nr   = 0;
+        page->active = 1;
+	}
+
+    // change the page to free if last block in active page
+	if( (page->active) && (page->refcount == 0) )
+	{
+        page->active = 0;
+		list_unlink( &page->list);
+		kcm->active_pages_nr --;
+
+		list_add_first( &kcm->free_root , &page->list);
+		kcm->free_pages_nr ++;
+	}
+}
+
+/////////////////////////////////////////////////////////////////////////////////////
+// This static function tries to allocate one page from PPM. It initializes
+// the KCM-page descriptor, and introduces the new page into freelist. 
+/////////////////////////////////////////////////////////////////////////////////////
+static error_t freelist_populate( kcm_t * kcm )
+{
+	page_t     * page;
+	kcm_page_t * ptr;
+
+    // get one page from local PPM
+	page = kcm_page_alloc( kcm );
+	if( page == NULL ) return ENOMEM;
+ 
+    // get physical page base address
+	ptr = ppm_page2base( page );
+
+    // initialize KCM-page descriptor
+	bitmap_set_range( ptr->bitmap , 0 , kcm->blocks_nr );
+
+	ptr->busy          = 0;
+	ptr->active        = 0;
+	ptr->refcount      = 0;
+	ptr->blk_tbl       = (uint8_t*)ptr + kcm->block_size;
+	ptr->kcm           = kcm;
+	ptr->page          = page;
+
+    // introduce new page in free-list
+	list_add_first( &kcm->free_root , &ptr->list );
+	kcm->free_pages_nr ++;
+ 
+	return 0;
+}
+
+/////////////////////////////////////////////////////////////////////////////////////
+// This private function get one KCM page from the KCM freelist.
+// It populates the freelist if required.
+/////////////////////////////////////////////////////////////////////////////////////
+static kcm_page_t * freelist_get( kcm_t * kcm )
+{
+	error_t      err;
+	kcm_page_t * page;
+
+    // get a new page from PPM if freelist empty
+	if( kcm->free_pages_nr == 0 )
+	{
+        err = freelist_populate( kcm );
+        if( err	) return NULL;
+	}
+
+    // get first KCM page from freelist and change its status to active 
+	page = LIST_FIRST( &kcm->free_root, kcm_page_t , list );
+	list_unlink( &page->list );
+	kcm->free_pages_nr --;
+    page->active = 1;
+
+    list_add_first( &kcm->active_root , &page->list);
+	kcm->active_pages_nr ++;
+    page->active = 1;
+
+	return page;
+}
+
+
+////////////////////////////////////
+error_t kcm_init( kcm_t       * kcm,
+		          uint32_t      type )
+{
+	uint32_t     blocks_nr;
+	uint32_t     block_size;
+	uint32_t     remaining;
+	kcm_page_t * page;
+
+	spinlock_init( &kcm->lock );
+
+    // initialize KCM type  
+	kcm->type = type;
+
+    // initialise KCM page lists
+	kcm->free_pages_nr   = 0;
+	kcm->busy_pages_nr   = 0;
 	kcm->active_pages_nr = 0;
-	list_root_init( &kcm->full_root );
+	list_root_init( &kcm->free_root );
+	list_root_init( &kcm->busy_root );
 	list_root_init( &kcm->active_root );
 
-	// initialize order 
-	kcm->order = order;
- 
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) )
-printk("\n[%s] cxy %x / order %d\n",
-__FUNCTION__, local_cxy, order );
-#endif
-
-}  // end kcm_init()
+    // initialize block size and number of blocks per page,
+    // using the global kmem_size_tbl[] array 
+	block_size      = ARROUND_UP( kmem_size_tbl[type] , 64 );
+	blocks_nr       = CONFIG_PPM_PAGE_SIZE / block_size;
+	remaining       = CONFIG_PPM_PAGE_SIZE % block_size;
+	blocks_nr       = (remaining >= sizeof(kcm_page_t)) ? blocks_nr : blocks_nr - 1;
+
+	kcm->blocks_nr  = blocks_nr;
+	kcm->block_size = block_size;
+
+    // get one page from free_list
+	page = freelist_get( kcm );
+	if( page == NULL ) return ENOMEM;
+     
+    // register page in active list
+	list_add_first( &kcm->active_root , &page->list );
+	page->active = 1;
+	kcm->active_pages_nr ++;
+
+	return 0;
+}
 
 ///////////////////////////////
 void kcm_destroy( kcm_t * kcm )
 {
-	kcm_page_t   * kcm_page;
-
-    // build extended pointer on  KCM lock
-    xptr_t lock_xp = XPTR( local_cxy , &kcm->lock );
-
-	// get KCM lock
-	remote_busylock_acquire( lock_xp );
-
-	// release all full pages
-	while( list_is_empty( &kcm->full_root ) == false )
-	{
-		kcm_page = LIST_FIRST( &kcm->full_root , kcm_page_t , list );
-		list_unlink( &kcm_page->list );
-		ppm_free_pages( kcm_page->page );
-	}
-
-    // release all empty pages
-    while( list_is_empty( &kcm->active_root ) == false )
-	{
-		kcm_page = LIST_FIRST( &kcm->active_root , kcm_page_t , list );
-		list_unlink( &kcm_page->list );
-		ppm_free_pages( kcm_page->page );
-	}
-
-	// release KCM lock
-	remote_busylock_release( lock_xp );
-
-}  // end kcm_destroy()
-
-//////////////////////////////////
-void * kcm_alloc( uint32_t order )
-{
-    kcm_t      * kcm;
-	kcm_page_t * kcm_page;
-	void       * block;
-
-// check argument
-assert( __FUNCTION__, (order < CONFIG_PPM_PAGE_ORDER),
-"order argument %d too large", order );
-
-#if DEBUG_KCM
-uint32_t cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // smallest block size is a cache line
-    if (order < CONFIG_CACHE_LINE_ORDER) order = CONFIG_CACHE_LINE_ORDER;
-
-    // get local pointer on relevant KCM allocator
-    kcm = &LOCAL_CLUSTER->kcm[order - CONFIG_CACHE_LINE_ORDER];
-
-    // build extended pointer on local KCM lock
-    xptr_t lock_xp = XPTR( local_cxy , &kcm->lock );
-
-	// get KCM lock
-	remote_busylock_acquire( lock_xp );
-
-    // get a non-full kcm_page
-    kcm_page = kcm_get_page( kcm );
-
-    if( kcm_page == NULL )
-	{
-		remote_busylock_release( lock_xp );
-		return NULL;
-	}
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] enter / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, local_cxy, kcm, kcm->full_pages_nr, kcm->active_pages_nr,
-kcm_page, (uint32_t)(kcm_page->status>>32), (uint32_t)(kcm_page->status), kcm_page->count );
-#endif
-
-	// allocate a block from selected active page
-	block = kcm_get_block( kcm , kcm_page );
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] exit  / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, local_cxy, kcm, kcm->full_pages_nr, kcm->active_pages_nr,
-kcm_page, (uint32_t)(kcm_page->status>>32), (uint32_t)(kcm_page->status), kcm_page->count );
-#endif
-
-	// release lock
-	remote_busylock_release( lock_xp );
-
-	return block;
-
-}  // end kcm_alloc()
+	kcm_page_t   * page;
+	list_entry_t * iter;
+  
+    // get KCM lock
+	spinlock_lock( &kcm->lock );
+
+    // release all free pages
+	LIST_FOREACH( &kcm->free_root , iter )
+	{
+		page = (kcm_page_t *)LIST_ELEMENT( iter , kcm_page_t , list );
+		list_unlink( iter );
+		kcm->free_pages_nr --;
+		ppm_free_pages( page->page );
+	}
+
+    // release all active pages
+	LIST_FOREACH( &kcm->active_root , iter )
+	{
+		page = (kcm_page_t *)LIST_ELEMENT( iter , kcm_page_t , list );
+		list_unlink( iter );
+		kcm->free_pages_nr --;
+		ppm_free_pages( page->page );
+	}
+
+    // release all busy pages
+	LIST_FOREACH( &kcm->busy_root , iter )
+	{
+		page = (kcm_page_t *)LIST_ELEMENT( iter , kcm_page_t , list );
+		list_unlink( iter );
+		kcm->free_pages_nr --;
+		ppm_free_pages( page->page );
+	}
+
+    // release KCM lock
+    spinlock_unlock( &kcm->lock );
+
+    
+}
 
 ///////////////////////////////
-void kcm_free( void    * block,
-               uint32_t  order )
-{
-    kcm_t      * kcm;
-	kcm_page_t * kcm_page;
-
-// check argument
-assert( __FUNCTION__, (block != NULL), 
-"block pointer cannot be NULL" );
-
-#if DEBUG_KCM
-uint32_t cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // smallest block size is a cache line
-    if (order < CONFIG_CACHE_LINE_ORDER) order = CONFIG_CACHE_LINE_ORDER;
-
-    // get local pointer on relevant KCM allocator
-    kcm = &LOCAL_CLUSTER->kcm[order - CONFIG_CACHE_LINE_ORDER];
-
-    // get local pointer on KCM page
-    intptr_t kcm_page_mask = (1 << (order + 6)) - 1; 
-	kcm_page = (kcm_page_t *)((intptr_t)block & ~kcm_page_mask);
-
-    // build extended pointer on local KCM lock
-    xptr_t lock_xp = XPTR( local_cxy , &kcm->lock );
-
-	// get lock
-	remote_busylock_acquire( lock_xp );
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] exit  / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, local_cxy, kcm, kcm->full_pages_nr, kcm->active_pages_nr,
-kcm_page, (uint32_t)(kcm_page->status>>32), (uint32_t)(kcm_page->status), kcm_page->count );
-#endif
-
-	// release the block to the relevant page
-	kcm_put_block( kcm , kcm_page , block );
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] exit  / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, local_cxy, kcm, kcm->full_pages_nr, kcm->active_pages_nr,
-kcm_page, (uint32_t)(kcm_page->status>>32), (uint32_t)(kcm_page->status), kcm_page->count );
-#endif
-
-	// release lock
-	remote_busylock_release( lock_xp );
-
-}  // end kcm_free() 
-
-
-/////////////////////////////////////////////////////////////////////////////////////
-//        Remote access functions
-/////////////////////////////////////////////////////////////////////////////////////
-
-/////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the kcm_remote_alloc() function.
-// It can be called by any thread running in any cluster.
-// It returns a local pointer on a block allocated from an active kcm_page.
-// It makes a panic if no block available in the selected kcm_page.
-// It changes the page status as required.
-/////////////////////////////////////////////////////////////////////////////////////
-// @ kcm_cxy  : remote KCM cluster identifier.
-// @ kcm_ptr  : local pointer on remote KCM allocator.
-// @ kcm_page : local pointer on remote active kcm_page to use.
-// @ return a local pointer on the allocated block. 
-/////////////////////////////////////////////////////////////////////////////////////
-static void * __attribute__((noinline)) kcm_remote_get_block( cxy_t        kcm_cxy,
-                                                              kcm_t      * kcm_ptr,
-                                                              kcm_page_t * kcm_page )
-{
-    uint32_t order  = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->order ) );
-    uint32_t count  = hal_remote_l32( XPTR( kcm_cxy , &kcm_page->count ) );
-    uint64_t status = hal_remote_l64( XPTR( kcm_cxy , &kcm_page->status ) );
-
-// check kcm_page not full
-assert( __FUNCTION__, (count < 63) , 
-"kcm_page should not be full / cxy %x / order %d / count %d", kcm_cxy, order, count );
-
-    uint32_t index  = 1;
-    uint64_t mask   = (uint64_t)0x2;
+void * kcm_alloc( kcm_t * kcm )
+{
+	kcm_page_t * page;
+	void       * ptr = NULL;   // pointer on block
+
+    // get lock
+	spinlock_lock( &kcm->lock );
     
-	// allocate first free block in kcm_page, update status,
-    // and count , compute index of allocated block in kcm_page 
-    while( index <= 63 )
-    {
-        if( (status & mask) == 0 )   // block found
-        {
-            hal_remote_s64( XPTR( kcm_cxy , &kcm_page->status ) , status | mask );
-            hal_remote_s32( XPTR( kcm_cxy , &kcm_page->count  ) , count + 1 );
-            break;      
-        }
-        
-        index++;
-        mask <<= 1;
-    }
-
-	// swich the page to full if last block
-	if( (count + 1) == 63 )
-	{
-		list_remote_unlink( kcm_cxy , &kcm_page->list );
-		hal_remote_atomic_add( XPTR( kcm_cxy , &kcm_ptr->active_pages_nr ) , -1 );
-
-		list_remote_add_first( kcm_cxy , &kcm_ptr->full_root , &kcm_page->list );
-		hal_remote_atomic_add( XPTR( kcm_cxy , &kcm_ptr->full_pages_nr ) , 1 );
-	}
-
-	// compute return pointer
-	void * ptr = (void *)((intptr_t)kcm_page + (index << order));
+    // get block
+    if( list_is_empty( &kcm->active_root ) )  // no active page
+    {
+		page = (kcm_page_t *)LIST_FIRST( &kcm->active_root , kcm_page_t , list );
+        ptr  = get_block( kcm , page );
+    }
+    else                                      // active page cannot be full
+    {
+        page = LIST_FIRST( &kcm->active_root , kcm_page_t , list );
+        ptr  = get_block( kcm , page );
+    }
+
+    // release lock  
+	spinlock_unlock(&kcm->lock);
 
 	return ptr;
-
-}  // end kcm_remote_get_block()
-
-/////////////////////////////////////////////////////////////////////////////////////
-// This static function is called by the kcm_remote_free() function.
-// It can be called by any thread running in any cluster.
-// It releases a previously allocated block to the relevant kcm_page.
-// It changes the kcm_page status as required.
-/////////////////////////////////////////////////////////////////////////////////////
-// @ kcm_cxy   : remote KCM cluster identifier
-// @ kcm_ptr   : local pointer on remote KCM.
-// @ kcm_page  : local pointer on kcm_page.
-// @ block_ptr : pointer on block to be released.
-/////////////////////////////////////////////////////////////////////////////////////
-static void __attribute__((noinline)) kcm_remote_put_block ( cxy_t        kcm_cxy,
-                                                             kcm_t      * kcm_ptr,
-                                                             kcm_page_t * kcm_page,
-                                                             void       * block_ptr )
-{
-    uint32_t order  = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->order ) );
-    uint32_t count  = hal_remote_l32( XPTR( kcm_cxy , &kcm_page->count ) );
-    uint64_t status = hal_remote_l64( XPTR( kcm_cxy , &kcm_page->status ) );
-    
-	// compute block index from block pointer and kcm_page pointer
-	uint32_t index = ((intptr_t)block_ptr - (intptr_t)kcm_page) >> order;
-
-    // compute mask in bit vector
-    uint64_t mask = ((uint64_t)0x1) << index;
-
-    if( (status & mask) == 0 )
-    {
-        printk("\n[WARNING] in %s : block[%x,%x] not allocated / kcm %x / kcm_page %x\n",
-        __FUNCTION__, kcm_cxy, block_ptr, kcm_ptr, kcm_page );
-        kcm_remote_display( kcm_cxy , kcm_ptr );
-        return;
-    }
-
-    // update status & count in kcm_page 
-	hal_remote_s64( XPTR( kcm_cxy , &kcm_page->status ) , status & ~mask );
-	hal_remote_s32( XPTR( kcm_cxy , &kcm_page->count  ) , count - 1 );
-
-	// switch the page to active if page was full
-	if( count == 63 )
-	{
-		list_remote_unlink( kcm_cxy , &kcm_page->list );
-		hal_remote_atomic_add( XPTR( kcm_cxy , &kcm_ptr->full_pages_nr ) , -1 );
-
-		list_remote_add_last( kcm_cxy , &kcm_ptr->active_root, &kcm_page->list );
-		hal_remote_atomic_add( XPTR( kcm_cxy , &kcm_ptr->active_pages_nr ) , 1 );
-	}
-
-}  // end kcm_remote_put_block()
-
-/////////////////////////////////////////////////////////////////////////////////////
-// This static function can be called by any thread running in any cluster.
-// It gets one non-full KCM page from the remote KCM.
-// It allocates a page from remote PPM to populate the freelist, and initialises
-// the kcm_page descriptor when required.
-/////////////////////////////////////////////////////////////////////////////////////
-static kcm_page_t * __attribute__((noinline)) kcm_remote_get_page( cxy_t    kcm_cxy,
-                                                                   kcm_t  * kcm_ptr )
-{
-    kcm_page_t * kcm_page;    // local pointer on remote KCM page 
-
-    uint32_t active_pages_nr = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->active_pages_nr ) );
-
-    if( active_pages_nr > 0 )       // return first active page
-    {
-        kcm_page = LIST_REMOTE_FIRST( kcm_cxy , &kcm_ptr->active_root , kcm_page_t , list );
-    }
-    else                            // allocate a new page from PPM
-	{
-        // get KCM order
-        uint32_t order = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->order ));
-
-        // get one kcm_page from PPM
-        xptr_t page_xp = ppm_remote_alloc_pages( kcm_cxy,
-                                                 order + 6 - CONFIG_PPM_PAGE_ORDER );
-	    if( page_xp == XPTR_NULL )
-	    {
-
-#if DEBUG_KCM_ERROR
-printk("\n[ERROR] in %s : failed to allocate page in cluster %x\n",
-__FUNCTION__ , kcm_cxy );
-#endif
-		    return NULL;
-        }
-
-	    // get extended pointer on allocated buffer
-	    xptr_t base_xp = ppm_page2base( page_xp );
-
-        // get local pointer on kcm_page
-	    kcm_page = GET_PTR( base_xp );
-
-	    // initialize kcm_page descriptor
-	    hal_remote_s32( XPTR( kcm_cxy , &kcm_page->count )  , 0 );
-	    hal_remote_s64( XPTR( kcm_cxy , &kcm_page->status ) , 0 );
-	    hal_remote_spt( XPTR( kcm_cxy , &kcm_page->kcm )    , kcm_ptr );
-	    hal_remote_spt( XPTR( kcm_cxy , &kcm_page->page )   , GET_PTR( page_xp ) );
-
-	    // introduce new page in remote KCM active_list
-	    list_remote_add_first( kcm_cxy , &kcm_ptr->active_root , &kcm_page->list );
-	    hal_remote_atomic_add( XPTR( kcm_cxy , &kcm_ptr->active_pages_nr ) , 1 );
-	}
-
-	return kcm_page;
-
-}  // end kcm_remote_get_page()
-
-//////////////////////////////////////////
-void * kcm_remote_alloc( cxy_t    kcm_cxy,
-                         uint32_t order )
-{
-    kcm_t      * kcm_ptr;
-    kcm_page_t * kcm_page;
-    void       * block_ptr;
-
-// check kcm_cxy argument
-assert( __FUNCTION__, cluster_is_active( kcm_cxy ),
-"cluster %x not active", kcm_cxy );
-
-// check order argument
-assert( __FUNCTION__, (order < CONFIG_PPM_PAGE_ORDER) ,
-"order argument %d too large", order );
-
-    // smallest size is a cache line
-    if( order < CONFIG_CACHE_LINE_ORDER ) order = CONFIG_CACHE_LINE_ORDER;
-
-    // get local pointer on relevant KCM allocator (same in all clusters)
-    kcm_ptr = &LOCAL_CLUSTER->kcm[order - 6];
-
-    // build extended pointer on remote KCM lock
-    xptr_t lock_xp = XPTR( kcm_cxy , &kcm_ptr->lock );
-
-	// get lock
-	remote_busylock_acquire( lock_xp );
-
-    // get a non-full kcm_page
-    kcm_page = kcm_remote_get_page( kcm_cxy , kcm_ptr );
-
-    if( kcm_page == NULL )
-	{
-		remote_busylock_release( lock_xp );
-		return NULL;
-	}
-
-#if DEBUG_KCM
-uint32_t cycle     = (uint32_t)hal_get_cycles();
-uint32_t nb_full   = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->full_pages_nr ));
-uint32_t nb_active = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->active_pages_nr ));
-uint64_t status    = hal_remote_l64( XPTR( kcm_cxy , &kcm_page->status ));
-uint32_t count     = hal_remote_l32( XPTR( kcm_cxy , &kcm_page->count ));
-#endif
-
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] enter / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, kcm_cxy, kcm_ptr, nb_full, nb_active,
-kcm_page, (uint32_t)(status>>32), (uint32_t)(status), kcm_page->count );
-#endif
-
-	// get a block from selected active page
-	block_ptr = kcm_remote_get_block( kcm_cxy , kcm_ptr , kcm_page );
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] exit  / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, kcm_cxy, kcm_ptr, nb_full, nb_active,
-kcm_page, (uint32_t)(status>>32), (uint32_t)(status), kcm_page->count );
-#endif
-
-	// release lock
-	remote_busylock_release( lock_xp );
-
-	return block_ptr;
-
-}  // end kcm_remote_alloc()
-
-////////////////////////////////////////
-void kcm_remote_free( cxy_t     kcm_cxy,
-                      void    * block_ptr,
-                      uint32_t  order )
-{
-	kcm_t      * kcm_ptr;
-	kcm_page_t * kcm_page;
-
-// check kcm_cxy argument
-assert( __FUNCTION__, cluster_is_active( kcm_cxy ),
-"cluster %x not active", kcm_cxy );
-
-// check block_ptr argument
-assert( __FUNCTION__, (block_ptr != NULL),
-"block pointer cannot be NULL" );
-
-// check order argument
-assert( __FUNCTION__, (order < CONFIG_PPM_PAGE_ORDER) ,
-"order argument %d too large", order );
-
-    // smallest block size is a cache line
-    if (order < CONFIG_CACHE_LINE_ORDER) order = CONFIG_CACHE_LINE_ORDER;
-
-    // get local pointer on relevant KCM allocator (same in all clusters)
-    kcm_ptr = &LOCAL_CLUSTER->kcm[order - CONFIG_CACHE_LINE_ORDER];
-
-    // get local pointer on KCM page
-    intptr_t kcm_page_mask = (1 << (order + 6)) - 1; 
-	kcm_page = (kcm_page_t *)((intptr_t)block_ptr & ~kcm_page_mask);
-
-#if DEBUG_KCM
-uint32_t cycle     = (uint32_t)hal_get_cycles();
-uint32_t nb_full   = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->full_pages_nr ));
-uint32_t nb_active = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->active_pages_nr ));
-uint64_t status    = hal_remote_l64( XPTR( kcm_cxy , &kcm_page->status ));
-uint32_t count     = hal_remote_l32( XPTR( kcm_cxy , &kcm_page->count ));
-#endif
-
-    // build extended pointer on remote KCM lock
-    xptr_t lock_xp = XPTR( kcm_cxy , &kcm_ptr->lock );
-
-	// get lock
-	remote_busylock_acquire( lock_xp );
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] enter / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, kcm_cxy, kcm_ptr, nb_full, nb_active,
-kcm_page, (uint32_t)(status>>32), (uint32_t)(status), kcm_page->count );
-#endif
-
-	// release the block to the relevant page
-	kcm_remote_put_block( kcm_cxy , kcm_ptr , kcm_page , block_ptr );
-
-#if DEBUG_KCM
-if( (DEBUG_KCM_ORDER == order) && (DEBUG_KCM_CXY == local_cxy) && (DEBUG_KCM < cycle) )
-printk("\n[%s] exit  / order %d / kcm[%x,%x] / nb_full %d / nb_active %d\n"
-"    page %x / status [%x,%x] / count %d\n",
-__FUNCTION__, order, kcm_cxy, kcm_ptr, nb_full, nb_active,
-kcm_page, (uint32_t)(status>>32), (uint32_t)(status), kcm_page->count );
-#endif
-
-	// release lock
-	remote_busylock_release( lock_xp );
-
-}  // end kcm_remote_free
-
-/////////////////////////////////////////
-void kcm_remote_display( cxy_t   kcm_cxy,
-                         kcm_t * kcm_ptr )
-{
-    list_entry_t * iter;
-    kcm_page_t   * kcm_page;
-    uint64_t       status;
-    uint32_t       count;
-
-    // get pointers on TXT0 chdev
-    xptr_t    txt0_xp  = chdev_dir.txt_tx[0];
-    cxy_t     txt0_cxy = GET_CXY( txt0_xp );
-    chdev_t * txt0_ptr = GET_PTR( txt0_xp );
-
-    // get extended pointer on remote TXT0 chdev lock
-    xptr_t    txt0_lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-    // get TXT0 lock 
-    remote_busylock_acquire( txt0_lock_xp );
-
-    uint32_t order           = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->order) );
-    uint32_t full_pages_nr   = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->full_pages_nr ) );
-    uint32_t active_pages_nr = hal_remote_l32( XPTR( kcm_cxy , &kcm_ptr->active_pages_nr ) );
-
-	nolock_printk("*** KCM : cxy %x / order %d / full_pages_nr %d / active_pages_nr %d\n",
-	kcm_cxy, order, full_pages_nr, active_pages_nr );
-
-    if( active_pages_nr )
-    {
-        LIST_REMOTE_FOREACH( kcm_cxy , &kcm_ptr->active_root , iter )
-        {
-            kcm_page = LIST_ELEMENT( iter , kcm_page_t , list );
-            status   = hal_remote_l64( XPTR( kcm_cxy , &kcm_page->status ) );
-            count    = hal_remote_l32( XPTR( kcm_cxy , &kcm_page->count ) );
-
-            nolock_printk("- active page %x / status (%x,%x) / count %d\n",
-            kcm_page, (uint32_t)( status<< 32 ), (uint32_t)( status ), count );
-        }
-    }
-
-    if( full_pages_nr )
-    {
-        LIST_REMOTE_FOREACH( kcm_cxy , &kcm_ptr->full_root , iter )
-        {
-            kcm_page = LIST_ELEMENT( iter , kcm_page_t , list );
-            status   = hal_remote_l64( XPTR( kcm_cxy , &kcm_page->status ) );
-            count    = hal_remote_l32( XPTR( kcm_cxy , &kcm_page->count ) );
-
-            nolock_printk("- full page %x / status (%x,%x) / count %d\n",
-            kcm_page, (uint32_t)( status<< 32 ), (uint32_t)( status ), count );
-        }
-    }
-
-    // release TXT0 lock 
-    remote_busylock_release( txt0_lock_xp );
-
-}  // end kcm remote_display()
+}
+
+///////////////////////////
+void kcm_free( void * ptr )
+{
+	kcm_page_t * page;
+	kcm_t      * kcm;
+  
+	if( ptr == NULL ) return;
+	
+	page = (kcm_page_t *)((intptr_t)ptr & CONFIG_PPM_PAGE_MASK);
+	kcm  = page->kcm;
+
+    // get lock
+	spinlock_lock( &kcm->lock );
+
+    // release block
+	put_block( kcm , ptr );
+
+    // release lock  
+	spinlock_unlock( &kcm->lock );
+}
+
+////////////////////////////
+void kcm_print (kcm_t * kcm)
+{
+	printk("*** KCM type = %d / free_pages = %d / busy_pages = %d / active_pages = %d\n",
+           kcm->type , 
+           kcm->free_pages_nr , 
+           kcm->busy_pages_nr ,
+           kcm->active_pages_nr );
+}
